#include <stdlib.h>

static char kleinZuGross(char z)
{
  if(z >= 'a' && z <= 'z')
  {
    return z - 'a' + 'A';
  }
  return z;
}

const static char tabelle[6][8]=
{
  {'B','F','P','V'},
  {'C','G','J','K','Q','S','X','Z'},
  {'D','T'},
  {'L'},
  {'M','N'},
  {'R'}  
};

char* soundex(char s[])
{  
  char* code = malloc(5);
  code[0] = kleinZuGross(s[0]);
  code[1] = '0';
  code[2] = '0'; // alternativ: *(code+2) = '0';
  code[3] = '0';
  code[4] = 0;
  
  int n = 1;
  
  for(int i = 1; s[i] != 0 && n < 4; i++)
  {
    int c = 0;
    char z = kleinZuGross(s[i]);
    for(int a = 0; a < 6; a++)
    {
      for(int b = 0; b < 8; b++)
      {
        if(z == tabelle[a][b])
        {
          c = a + 1 + '0'; // ineffizient: beide Schleifen abbrechen
        }
      }
    }
    if(c != 0 && (n == 1 || c != code[n-1]))
    {
      code[n] = c;
      n++;
    }
  }
  
  return code;
}